﻿EnableExplicit

;#gDrawing_NO_DLL_IMPORT = 1

XIncludeFile "gDrawing.pbi"

If gInit()

    Define metafile, y

    ;
    ; create a metafile, virtual size 40 * 40 pixels
    ;
    If gStartDrawing( gMetafileOutput(@metafile,40,40,"myfile.emf") )

        gSetFont("Courier New",10,#PB_Font_Italic)
        gSetPenSize(1.1)
        For y = 0 To 40
            gLineXY(0,y,40,y,RGBA($00,y*5,$00,$FF))
        Next y

        gSetPenSize(1) ; 0.1

        gCircle(20,20,10,RGBA($FF,$00,$00,$FF))
        
        gDrawText(20-gTextWidth("Hi")*0.5,20-gTextHeight()*0.5,"Hi")
        
        gDrawingMode(#PB_2DDrawing_Outlined)
        gCircle(20,20,15,RGBA($FF,$FF,$00,$FF))
    
        gStopDrawing()
    EndIf


    ;
    ; display the metafile with scaling
    ;
    Define mainWin, img

    mainWin = OpenWindow(#PB_Any,0,0,800,600,"gDrawing feature demo",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    img = CreateImage(#PB_Any,800,600,24)
    If gStartDrawing( ImageOutput(img) )
        gClear( RGBA($40,$40,$40,$FF) )

        gDrawImage(metafile,10,10)
        
        gDrawImage(metafile,100,10,200,200)

        gDrawImage(metafile,350,10,400,400)
        
        gDrawClippedImage(metafile,10,250,300,300,0,0,20,40)

        gStopDrawing()
    EndIf
    ImageGadget(#PB_Any,0,0,800,600,ImageID(img))
    Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

    gEnd()
EndIf

; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 13
; EnableUnicode
; EnableXP
; Executable = example24 - FontBrowser.exe
; CPU = 5
; CompileSourceDirectory